(oglwin '.gl)
(pack  .gl) 
(define hello (make-vector 10 ()))

(define  font (.gl 'loadbitmapfont))

(define  (dlist-rec x y)
   (let* ((dlist  (.gl 'newlist)))
      (.gl 'eval :newlist dlist 'compile
	:clear 'colorbuffer 
        :color 1 1 0
	:rasterpos x y )
      (.gl 'printstring font "Cat")
      (.gl 'eval :endlist) 
    dlist
))

(define *dlist*  (dlist-rec -1 0))

(do ((i 0 (+ i 1)))
    ((= i 1000))
    (.gl 'eval
         :matrixmode 'projection
         :loadidentity
          :rotate i 1 0 0
          :rotate i 0 1 0
         :call *dlist*
    )
    (.gl 'redraw)
    (update)
    (after 20)
)


