;;;  ms.ss --->  compiler.ss
;;;; emulate stack machine M
;;;;   see  note-cc
;;;   Only compile version
;;;;  pc-stack is list image
;;;;;;;;   compile  tail  is now subr!!!
;;;;;;;;   03.12.18
;;;;;;;;

(in-package "compiler")

;;;(load  "pathname")
(load "compile-file")

(load "m-comp")
(load  "m-opt")   
;;;;(load  "tail-m")
(load "opt-var")
(load "compiler-load")
;;;;(load "let")   ;;;;;   04.4.23 syntax-macro 

(define env ())
(define top-env ())
;;;  we indtroduce MPU-stack 
;;;   env,narg are  stacked here
;;;   also pc-stack is stored for execute M-Compiled function
;;;;
(define *verbose* #t)

;;;;(define TAIL-CALL :TAIL)

(define MPU ())

(define stack ())
(define pc-stack ())
(define level 0)
(define narg  0)
(define undef (make-undef))
(define scm undef)
(define *dynamic* ())
(define *label*  0) 
 ;;; to avoid confliction of lambda-vars and let-vars
;;;;   䡢blockNo.levelǤϤʤlabel ˤ롣
(define block-stack ()) ;;; block-label-stack
(define *comp* ())
(define access ())
;;;(define *dummy-func*  (list :LAMBDA :UNDEF) ) ;;; for letrec tric, eq? enable
;;;;(define *load-undef* (list :LOAD :IMMIDIATE undef))   ;;; for set!
(define *lambda-stack* ())   ;;;;  03.12.9
(define (label++)
 (set! *label* (+ 1 *label*))
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;   for debug of C 
;(define (meval s)
;  (set! s (mcompile s))
;  (mc-eval s ())
;)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(define (--MPU)
   (pop MPU)
)

(define (MPU++ x)
   (push x  MPU)
)

(define (--PC)
   (pop pc-stack )
)

(define (--stack)
   (pop  stack)
)
(define (pull-stack n)
   (do ()
       ((= n 0))
       (set! stack (cdr stack))
       (set! n (- n 1))
    )
 stack
)

(define (PC++ x)
   (push x  pc-stack )
)

;;;(define (PC++op x)    ;;;;;  needs , because compile myself or including keyowrd program!!
;;;   (push (list x) pc-stack)
;;;)

(define (stack++ s)
   (push s  stack )
)

;;;(define (outcom s)
   ;;;(push (list s narg stack) *comp* )  ;;;;for debug
;;;   (push  s  *comp* )
;;;   undef
;;;)

;;;(define (narg++)
;;   (set! narg (+ narg 1))
;;)

;;;(;;define (narg--)
;;   (set! narg (- narg 1))
;;;)

;;;(define (level++)
;;;   (set! level (+ level 1))
;;;)

;;;(define (level--)
;;;   (set! level (- level 1))
;;;)

;;;; (not c)   compiled as a macro    03.11.24
(define *system-not* not)   ;;;;¸
#|   04.4.23   --->  syntax.ss
(define-macro (not c)
  `(if ,c #f #t)
) 
(define *macro-not* not)
(set! not *system-not*)
|#

;;(define (special? x)
;;  (member x '
;;    (
;;       ;;;restore-cc make-cc
;;      call/cc  set! TAIL-CALL
;;      define let let* letrec begin quote if lambda macro )))


(define (compile-process  s)
  ;(set! not *macro-not*)
  (set! MPU ())
  (set! stack ())
  (set! narg 0)
  (set! env ())
  (set! scm undef)
  (set! pc-stack ())
  (set! *comp* ())
  (set! *label*  0)
  (set! *comp* ())
   (set! *lambda-stack* ())   ;;;;  03.12.9
  (set! scm s)
 ;;;  (PC++ scm)
  ;;  (set! scm (M))
   ;;;   (display "value: ")
      (set! *comp* (compile s))
     ;;; (print-comp)
      (set! *comp* (m-opt *comp*))  ;;;optimize
      (if-syori *comp*)
    ;;;;  (print-comp)
      (newline)
      (print-list *var-access* "var-access")
  ;;;    (print-list *var-value* "var-value")
      (print-list *frame-table* "frame-table")
 ;;;  out of top
 (set! not *system-not*)
 *comp*
)


(define (print-comp)
    (print-list *comp* "compiled!")
  (format #t "~% narg ~s env ~s MPU ~s level ~s stack ~s~%" narg env MPU level stack) 
)

(define (print-list s mesg)
  (format #t "~% ~a   ~%" mesg)
    (while (pair? s)
      (write (car s))
      (newline)
      (set! s (cdr s))
    )
)

(export 'compile-file)
(use-package "compiler" "ss")
