;;;;  mesg-dialog
;;;  short message display
;;;  if des is given, after 500msec, disapper
;;; 
(in-package "dialog")
(define (mesg-dialog mesg . des) 
  (let* ((top (gen-toplevel ".msg")) (mg (tk-name top '.msg)) (size 10))
    ;;(wm 'geometry top  "250x70+700+200")
   (if (pair? des) (set! size 14))
   (message  mg  :bg 'blue :fg 'white :aspect 250 :justify 'left
        :text mesg :font (list 'courier size))
   ;(entry '.load.file )
   (grid mg :sticky 'news )
   (event 'add "<<fin>>" "<ButtonPress-1>" "<KeyPress>")
   (if (null? des)(bind top  "<<fin>>" (lambda () (destroy top))))
   (tkwait 'visibility top)
    (focus top)
    (grab top)
    (if (pair? des) (tk:after 500 `(destroy ,top)))
    (tkwait 'window top)

))

(export 'mesg-dialog)
(use-package "dialog" "ss")










