;;;  original program is written by Toyama  (2001 sotu)
;;;  modified by sato  2002.7.17
;;;  2003.11.5   SS version
;;;;

;;;(load "init")

;;;;;;;;;;;リストL中で16が何番目にあるか判定;;;;;;;;;;;;;;;;;;;;;;;;;
(define (where16 l)
  (do ( (i 1 (+ i 1))
      )
      ((eq? (car l) 16) i)
        (set! l (cdr l))
  )
)
;;;;;;;;;;;;;;;;;;何gyou目にnがあるか判定;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;   return 1 for n=1-4, 2 for 5-8,...
(define (get-row n)
      (floor (/ (+ n 3) 4)) )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(define (1-to-n x)
  (do ( (z ())) 
      ((=  x 0)  z)
       (push x  z)
       (set! x (- x 1))
  )
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(define (shuffle x)
  (let ((k 0))
    (if (eq? x ())
          ()
      (begin
        (set! k (random (length x)))
        (set! k (list-ref x k))
        (cons k (shuffle (remove k x)))
     )
   )
))
;;;;    shuffle even(100)  permutation!! for 15-puzzle
;;;;  last 16 is unchanged
;;;;
(define (15shuffle)
   (let ((i 0)(j 0)(v 0) (x 0))
     (set! v (list->vector (1-to-n 15)))
     (do ((n  0))
         ((= n 100) (append (vector->list v) (list 16)))
          (set! i (random 15))
          (set! j (random 15))
          (if (= i j)  
                   ()
            (begin
              (set! x (vector-ref v i))
              (vector-set! v i (vector-ref v j))
              (vector-set! v j  x)
              (set! n (+ n 1))
          )
        )
    )
))         

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(define *goal*  (1-to-n 16))
;;; (define *ban*  (shuffle *goal*)) 
(define *ban*  (15shuffle )) 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;リストLの中の数字Xを16と交換;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(define (change16 l x)
  (do ( (m ()) (top 0))
      ((eq? l ()) (reverse m))
        (set! top (pop l))
        (push  (cond ((= top x)
                        16
                      )
                      ((= top  16)
                         x
                      )
                      (#t  
                        top
                      )
                )
          m
        )
  )
 )
;;;;;;;;;;;;;;15パズル成功の証;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(define (change-clear)
   (let ((i 0) (j 0) (y 0) (fr 0) (bt 0))
    (do 
       ((i 1 (+ i 1)))
       ((= i 5))
       (set!  fr (tk-name ".delo"  ".f" i))
       (do 
          ((j 1 (+ j 1)))
          ((= j 5))
          (set! y (+ y 1))
          (set! bt (tk-name fr ".b" y))
          (eval`(,bt 'configure :text "clear!!!"
                                :command "exit"
                                :relief 'flat
                )
            ()
          )     ;;;   needs () for ss
       )
     )
    )
)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(toplevel '.delo)
(define (start)
      (let ((x *ban*) (y 0)  (n 0)  (bt 0) (fr 0))
	(do
            ((i 1 (+ i 1)))
            ((= i 5))
            (format #t "i: ~s~%" i)
            (set!  fr (tk-name  ".delo" ".f" i))
            (frame fr)
            (pack fr :side 'top)
            (do
               ((w 1 (+ w 1)))
               ((= w 5))
               (set! y (+ y 1))
               (set! bt (tk-name fr ".b" y))	
               (set! n (pop x))
               (format #t "~s ~%" bt)
               (button bt
                        :text (if (= n 16)
                                   " "
                                   n
                              ) 
                        :relief (if (= n 16)
                                   'flat
                                   'raised
                                ) 
                        :height 3
                        :width 6
                       ;:border 0
                       ;:padx 0 :pady 0
                        :command `(idou  ,bt ,y)
               )
               (pack bt :in fr :side 'left)
             )
	 )
       (button '.delo.exit :text "EXIT" :command "exit")
       (pack .delo.exit)
       )
)
(define (idou  b c)
  (let ((delo 0) (pat 0) (pos16 (where16 *ban*)))
   
   (set! delo (tk-name ".delo"  ".f" (get-row pos16) ".b"  pos16) )

   ;;; local function change ban   
   (define (sousa)
     (eval`(,b 'configure :text ," " :relief 'flat) ())
     (eval`(,delo 'configure :text ,(list-ref *ban* (- c 1)) :relief 'raised) ())
     (set! *ban* (change16 *ban* (list-ref *ban* (- c 1))))
     (format #t "~s ~%" *ban*)
     (format #t "~s ~%" 
     (if (equal? *ban* *goal*) (change-clear) "no!!"))
   )
    (format #t "~s ~%" b)
    (format #t "~s ~%" delo)
    (format #t "~s ~%" *ban*)
   ;;;
  (set! pat (modulo c 4))   ;;;  1  is left edge, 0 is right edge
   (cond ((= pat 1)
            (if(= (+ c 1) pos16) (sousa)))
        ((= pat 0)
             (if(= (- c 1) pos16) (sousa))  )
        (#t 
              (if(= (+ c 1) pos16) (sousa))
              (if(= (- c 1) pos16) (sousa))
         )
   )
  (if(= (+ c 4) pos16) (sousa))
  (if(= (- c 4) pos16) (sousa))
))
                  

(start)

