;;;  for ss version 04.4.23  converted from init.scm
;;;
;;;
#|
(define-macro (else  . body)
  `(begin ,@body))

(define (princ x)
   (display x))
|#

(define nil ())

(define-syntax define-vars 
   (syntax-rules ()
     ((define-vars a b) (define a b))
     ((define-vars  a b c ...)
       (begin (define a b) (define-vars  c ...)))
   )
)

(define-syntax defconstant
   (syntax-rules ()
     ((defconstant a b) (begin (define a b) (constant! (quote a))))
   )
)

(define-syntax swap
   (syntax-rules ()
     ((swap a b) (let* ((temp a)) (set! a b) (set! b temp))) 
   )
)


(define (make-list n initial)
   (do ((s ()))
      ( (= n 0)  s)
      (push  initial s)
      (dec n)
   )
)

#|
(define (logbitp index integer)
  (= 1 (logand 1 (ash integer (- index))))  )
|#
;;;;;;;
(define (logx-y x y)
   (logxor x (logand x y)))

;;;

(define *tk-top* "")

(define (tk-top name)
  (set! *tk-top* name)
  (toplevel name)
)

(define (err-occur v1 v2)
   (format #t "~% ~a ~a ~%???" v1 v2)
   (car) )

;;;string
(define (string-reverse str)
  (let ((s()))
    (set! s (string->list str))
    (list->string (reverse s))
))

(define-syntax tk-conc
  (syntax-rules ()
    ((tk-conc a ...) (tk-string a ...))
  )
)



