;;;(load "initogl.scm")

(define picture #f)
(define *xrot* 0)
(define *yrot* 0)
(define *mouse-x* 0)
(define *mouse-y* 0)

  

(define (compute_picture line-points vertexs)
  (let ((l ()) (lines '(:end)) (vtxs ()) (vtxhead ()))
    (set! l
	   '(:clear colorbuffer depthbuffer 
	    :shademodel flat 
	    :begin linestrip))
    (do ()
        ((null? line-points)) 
	(set! lines (cons :vertex (append (pop line-points) lines))) 
         
    )
   (set! vtxhead '(:initnames :pushname -1 :pointsize 5)) 
    (do ((i 0 (+ i 1)))
        ((null? vertexs))
        (push :end vtxs )
        (set! vtxs (append (pop vertexs) vtxs))
	(set! vtxs (append  `(:loadname ,i :begin points 
                  :vertex ) vtxs))
    )
    (set! l (append l lines vtxhead vtxs))
   (format #t "l=~s~%" l)
   (if  picture (.my.gl 'deletelist   picture ))
   (set!  picture (apply  .my.gl 'newlist  l))
))
    
(define ( redraw)
   
   ( .my.gl 'main 
	    :matrixmode 'projection 
	    :loadidentity 
	    :ortho -4 4 -4 4 -4 4 
	    :matrixmode 'modelview 
	    :loadidentity 
	    :rotate *yrot* 1 0 0
	    :rotate *xrot* 0 1 0
	    :call picture
))

(toplevel '.my)
(oglwin '.my.gl)
(pack  .my.gl :expand 'yes :fill 'both)

(compute_picture '((1 1 0) (0 0 1) (0 1 1)) '((1 1 0)))
	
(set! *xrot* 10) 
(set!  *yrot* 10)

(bind .my.gl "<Button-1>" (lambda (x y) (set!  *mouse-x* x)( set! *mouse-y* y)))

(bind .my.gl "<B1-Motion>" 
  (lambda (x y) 
    (set! *xrot* (+  *xrot* (- x *mouse-x*))) 
    (set! *yrot* (+  *yrot* (- y *mouse-y*))) 
    (set!  *mouse-x* x)
    (set!  *mouse-y* y)
    (redraw)
))
;(bind .my.gl "<Button-3>" (lambda (x y)( pick_point x y )))

;(bind .my.gl "<B3-Motion>" (lambda (x y)(move_point x y )))
(redraw)







