;;;;  Caution!st
;;;  Never use  define for tk-variables
;;; for example 
;;;  (define img ())
;;; then img is only used in stk , and can't get tk-function  bind!!!
;;;;;

(define redisplay
    (lambda()
       (.gl 'main :matrixmode 'projection
            :loadidentity
            :perspective 30 1 0.1 10
            :matrixmode 'modelview
            :loadidentity
            :lookat -3 2 3  0 0 0  0 1 0
            :clear 'depthbuffer 'colorbuffer
            :rotate yrot 1 1 0 :call dlist)
        (set! yrot (+  yrot 5))
        (after 20 '(redisplay))
    )
)

(pack (oglwin '.gl :width 300 :height 300)
        :side 'left :expand 'yes :fill 'both)


(image 'create 'photo 'img :file "logo128.gif")
(.gl 'eval :teximage2d 0 0 'img)


(.gl 'eval :teximage2d 0 0 'img
	:enable 'depthtest 
	:texparameter 'texture2d 'texturewraps 'repeat
	:texparameter 'texture2d 'texturewrapt 'repeat 
	:texparameter 'texture2d 'texturemagfilter 'nearest 
	:texparameter 'texture2d 'textureminfilter 'nearest 
	:texenv 'textureenv 'textureenvmode 'modulate
	:texgen 's 'objectplane  1 0 0 0
	:texgen 't 'objectplane  0 0 1 0
	:shademodel 'smooth 
	:enable 'texture2d 
	:light 'light0 'ambient 1 1 1 1 
	:light 'light0 'diffuse 1 1 1 1 
	:light 'light0 'position 1 1 1 0 
	:light 'light0 'specular 1 1 1 1 
	:enable 'lighting :enable 'light0 
	:material 'front 'ambient 0.4 0.4 0.4 
	:material 'front 'diffuse 0.5 0.5 0.5 
	:material 'front 'specular 0.5 0.5 0.5 
	:material 'front 'shininess 50 
	:enable 'depthtest 
	:enable 'lighting
)

(define  info (.gl 'gencyl :texgen 0 1 0 1 :polygon 0.5 20
      :plot :transl 0 0 1 :plot))

(define  dlist (list-ref (list-ref info 0) 1))
;;;;;   may be STk's Bug
;;;;  thisb info result should be the list of list
;;;; However , returned plain list!
;;;;
;;; (define  dlist (list-ref info  1))       ;;; For STk  change the above this 
(define yrot 0)
(redisplay)


