#define  TSIZE       128

/*** type  ***/
#define  constituent   (ptr)   5   /***  SINT 1 ***/
#define  t_space      (ptr)0x09
#define  s_escape     (ptr) 0x11
#define  m_escape      (ptr)0x31
#define  t_macro       (ptr)0x41
#define  non_t_macro  (ptr)0x141
#define  sharp_macro  (ptr)0x341 /** non_t_macro & dispatch macro**/
#define  illegal      (ptr)0x8001

/*** flag  ***/
#define  constituent_flag   0x04
#define  space              0x08
#define  escape             0x10
#define  multi              0x20
#define  macro              0x40
#define  non_t_flag        0x100
#define  dispatch          0x200

#define is_macro(x)     (((long)x)&macro)
#define is_non_t(x)     ((((long)x)&(long)non_t_macro)==(long)non_t_macro)
#define is_t_macro(x)   ((((long)x)&(long)non_t_macro)==(long)t_macro)
#define  TOK_MAX    1024  
#define  KANJIP(x)   (kanji_mode&&kanjip(x))  /***  ((x)&0xff)>127) **/

#ifdef READ_MAIN
char *tokstr;  /** [TOK_MAX]; **/
char  *esc_tokstr;  /** [TOK_MAX]; **/   
int tok_max;
int loc_tok;
int esc_flag;
int preserving;   /**** preserving-whitespace flag ***/
ptr read_vector; 
#else
extern char  *tokstr,*esc_tokstr;
extern int loc_tok;
extern int esc_flag;
#endif 
/** extern ptr read_vector,a_readtable; **/
/*** int rm_error;   for read-macro  -> lisp.h  ***/

#define open_tok()    (loc_tok=0)
#define close_tok()    (makestring_p(tokstr,loc_tok))

ptr mxtoken(),extoken();


extern int f_loc[];

#define l_feof(s)   ((ptr)peekchar(s)==SEOF)

/*****  original is CL09   89.4.25
   extended   read routine for COMMON LISP type of READ MACRO  */

/**** for read_m.c ***/

