/***   funcall.c
   03.12.21
   from sseval.c   
   for MC  code
***/

#define FUNCALL

#include "lisp.h"
#include <stdio.h>

extern ptr k_Q,k_F;
//extern ptr *MPC;
extern ptr vm_eval();

/** extern PUSH_REG();  **/

extern ptr *pc_stack,M(),M_exp(),M_mc();
//extern int narg,level;

ptr s_function(int narg,ptr env){
  Reg ptr func,orig;
  checknarg(narg-1);
  orig=func=*(stack-1);
 loop:
     if(SREGP(func)) error(E_nullfunc,orig);
     if(SYMBOLP(func)) {
         /***  eval  interaction , impossible && we only get global def ***/
        func=ATOMVAL(func);
        goto loop;
     }
     if(!CLOSUREP(func)) error(E_nullfunc,orig);
   return func;
}

/*** for compiler  , and more  ***/

extern ptr sr2_funcall();

ptr funcall(ptr func,int nar,ptr env){
  Reg   ptr (*addr)(),fenv,*mpc,orig;
  int type;
     orig=func;
   loop:
     if(SREGP(func)) error(E_nullfunc,func);
     if(SYMBOLP(func)) {
         /***  eval  interaction , impossible && we only get global def ***/
        func=ATOMVAL(func);
        goto loop;
     }
   type=ATTR(func);
     if((type&CLOSURE)==0) error(E_nullfunc,orig);
   
   /*** printf("funcall addr %x %d %x stack %x  ",addr ,nar,type,stack); **/

      /*** if(!(type&SUBR)) return funcall_lambda(type,nar,addr,env,fenv); **/
     if(type==SR2) 
           return sr2_funcall(func,nar);  /*** V2.0  ***/
     else if(type==SLAMBDA){   /***  compiled system lambda   ***/
               /*** scm=(* addr)(nar,fenv);  *** ???? ***/
       addr=(ptr (* )())FBODY(func);
       fenv=FENV(func);
               return (* addr)(nar,fenv);  /**** ???? ***/
      }
     else{   /*** macro  subr  to be modify!!! ***/
          error(E_illegal,orig);
         /**
         psh(func=(* addr)(nar,fenv));
         func=vm_eval(func,env); 
         ***/
        return func;
    }
}

ptr s_funcall(int nar,ptr env){
  if(nar==0) checknarg(-1);
  return funcall(*(stack-nar),nar-1,env);
}
