;;;;  Optimize 
;;;;   2003.11.24
;;;
(in-package "compiler")

(define *comp-vector* ())
(define *opt-count* 0)
(define *comp-size* 0)
(define NOP (list #f))

(define *label-link* ())  ;;;  label link count  as ((3 . 1 ) (5 . 2) ...)
(define *var-access* ())  ;;;   access record for var's
(define *var-value* ())
(define *letrec-var* ())
;;;(define *var-change* ())  ;;;   for debug not used

;;;(load "letbind")
(load "var-access")

(define (m-opt comp-list)
  (let* ((no-int #t))
    (make-comp-vector comp-list)
    (set! no-int  (no-interaction))
    ;;;;(opt-letbind)
    (make-var-access ())
    ;(format #t "m-opt-var  debug ~%")
    ;(print-comp-vector)
    (set! *opt-count* 1)
   ; (while (> *opt-count* 0)
   ;      (set! *opt-count* 0)
   ;      (change-letbind)
   ; )
    (clean-comp -1)  ;;;; force clean NOP
    ;;(format #t "m-opt-letbind  debug ~%")
    (print-comp-vector)
    ;;;(read)

       (m-opt-exec no-int)

    ;;; frame var
    ;(format #t "make-out-access ~%")
    (when no-int
         (make-out-access)
    ;(format #t "cahnge-frame ~%")
    ;(print-comp-vector)
         (change-frame-var)
    ;(format #t "cahnge-frame end  ~%")
    ;(print-comp-vector)
    ;(read)
        (clean-comp -1) 
    ;(format #t "opt-block ~%")
       (m-opt-exec no-int)
    )
    (load-imm-change)
    (final-comp)
    (get-comp-list) ;;; :warning deleted! 
))
 
(define (m-opt-exec no-int)
  (let ((n 0))
    (set! *opt-count* 0)
    (make-var-access ())
    (if no-int
      (begin
        (opt-nobind)   ;;;var-access
        (set! n (clean-comp n)) 
        (opt-block)   ;;;var-access
        (set! n (clean-comp n)) 
      )
     )

    (opt-bind)
    (set! n (clean-comp n)) 
    (opt-load-imm)
    (set! n (clean-comp n)) 
    (opt-load)
    (set! n (clean-comp n)) 
    (opt-load-set)
    (set! n (clean-comp n)) 
    (opt-set-load)
    (set! n (clean-comp n)) 
    (opt-load-jmp)
    (set! n (clean-comp n)) 
    ;;(format #t "m-opt  debug ~%")
    ;;(print-comp-vector)

    (opt-label-label)
    (set! n (clean-comp n)) 
    ;;(format #t "m-opt  debug 3 ~%")
    ;;;(print-comp-vector)
    (opt-jmp-label)
    (set! n (clean-comp n)) 
    ;;;(format #t "m-opt  debug 2 ~%")
    ;;(print-comp-vector)

    (label-clean)
    (set! n (clean-comp n)) 
    (opt-jmp-nolabel)
    (set! n (clean-comp n)) 
    (opt-scm-jmp)
    (set! n (clean-comp n)) 
    (opt-if-jmp)
    (set! n (clean-comp n)) 
    (opt-op-jmp)
    (set! n (clean-comp n)) 
    ;;(format #t "m-opt ~%")
    ;;(print-comp-vector)
    (if (> *opt-count* 0) 
           ;;;(m-opt (get-comp-list))
           (begin
           (format #t "m-opt count ~s  ~%" *opt-count*)
           (m-opt-exec no-int)
           )
          ;;;; (cons *opt-count* (get-comp-list)) ;;; :warning deleted! 
    )
))

(define (make-comp-vector v)
   (let ((n 0 ) (x 0) (top 0)(lab 0) )
      (set! n (vector-length v))
     (do ((i 0))
         ((= n i))
         (set! x (vector-ref v i))
         (set! top (car x))
         (if (eq? top :warning)
             (vector-set! v i NOP)
         )
        (if(eq? top :LABEL)
           (if (> (cadr x) lab) (set! lab (cadr x)))   ;;;; max label
        )
        ; ;;(if (and (eq? (car x) :LOAD)(pair? (cddr x)) (eq? (caddr x) *dummy-func*))
        ; ;;    (vector-set! v i NOP);;;   dummy value for letrec
        ;;  )
         (set! i (+ i 1))
     )
  (set! *label* (+ lab 1))
  (set! *comp-vector* v)
  (set! *comp-size* n)
  (clean-comp -1)
))
#|
(define (clean-dummy)
  (let ((v *comp-vector*)(n  *comp-size*) (x 0)(res ()))
     (do ((i 0))
         ((= n i))
         (set! x (vector-ref v i))
        (if (and (eq? (car x) :LOAD)(pair? (cddr x)) (eq? (caddr x) *dummy-func*))
            (vector-set! v i NOP);;;   dummy value for letrec
         )
         (set! i (+ i 1))
     )
  (clean-comp -1)
))
|#

(define (get-comp-list)
  (let ((v *comp-vector*)(n  *comp-size*) (x 0)(res ()))
  ;;;   (clean-dummy)
     (do ()
         ((= n 0) res)
         (set! n (- n 1))
         (set! x (vector-ref v n)) 
         (if (car x)
             (set! res (cons x res))
         )
     )
 )
)

(define (no-interaction)
  (let ((v *comp-vector*)(n  *comp-size*) (x 0)(res #t))
     (format #t "no-interaction enter~%")
     (do ()
         ((= n 0) res)
         (set! n (- n 1))
         (set! x (vector-ref v n))
         (and (eq? (car x) :LOAD)(eq? (cadr x) :REG) 
              (eq? (caddr x) :ENV)   ;;;;;'interaction-environment)
              (begin (set! res #f) (set! n 0))
         )
     )
     (format #t "no-interaction out ~s~%" res)
   res
 )
)

(define (print-comp-vector)
  (let ((v *comp-vector*)(n  *comp-size*) (x 0))
     (do ((i 0))
         ((= n i) )
         (set! x (vector-ref v i))
         (if (car x)
             (format #t "~s~%" x)
         )
        (set! i (+ i 1))
     )
 )
 (newline)
)


(define (clean-comp k)
  (if (< k *opt-count*)
    (let ((v *comp-vector*)(n  *comp-size*) (x 0) (j 0))
       (do ((i 0))
         ((= n i) )
         (set! x (vector-ref v i))
         (when (car x)
             (vector-set! v j x)
             (set! j (+ j 1))
         )
         (set! i (+ i 1))
       )
      (while (< j n)
         (vector-set! v j NOP)
             (set! j (+ j 1))
      )
    )
  )
 *opt-count*
)


(define (opt-letbind)
   (let ((v *comp-vector*)(n  *comp-size*)(x 0) (prev '(a)))
     (do ((i 0))
         ((= n i) )
         (set! x (vector-ref v i))
         (when  (and  (eq? (car x) :LETBIND))
             (and  (= (length (cadr x)) 1)
                   (eq? (car prev) :STACK-NARG)
                 (begin
                    ;;;(format #t "opt-letbind ~s  prev ~s~%" x prev)
                    (vector-set! v (- i 1) NOP)
                    (vector-set! v  i  (list :BIND (caadr x)))
                    (inc-opt)
                 )
             )       
         )
         (set! prev x)
         (set! i (+ i 1))
     )
 )
)

(define (inc-opt)
  (set! *opt-count* (+ 1 *opt-count*))
)

(define (load? x)
  (eq? (car x) :LOAD)
)

(define (load-env? x)
  (and (eq? (car x) :LOAD) (eq? (cadr x) :ENV))
)


(define (set? x)
  (eq? (car x) :SET)
)

(define (set-env? x)
  (and (eq? (car x) :SET) (eq? (cadr x) :ENV))
)

(define (label? x)
  (eq? (car x) :LABEL)
)

(define (lambda-begin? x)
  (eq? (car x) :LAMBDA-BEGIN)
)  

;;;   (:BIND x)(:LOAD :ENV x)-> (:BIND x)
(define (opt-bind)
   (let ((v *comp-vector*)(n *comp-size*)(x 0) (prev #f))
     (do ((i 0))
         ((= n i) )
         (set! x (vector-ref v i))
         (when  (and  prev  (load-env?  x) (equal? (cadr prev) (caddr x)))
              (vector-set! v  i  NOP)
              (inc-opt)
         )
         (if (eq? (car x) :BIND) 
               (set! prev x)
               (set! prev #f)
         )
         (set!  i(+ i 1))
     )
 )
)

(define (opt-load)
   (let ((v *comp-vector*)(n *comp-size*)(x 0) (prev-ind 0)(prev #f))
     (do ((i 0)) 
         ((= n i) )
         (set! x (vector-ref v i))
         (when  (and prev  (or (load?  x)  
                   (and (label? x) (load?(vector-ref v (+ i 1))) ) ) )
              (vector-set! v  prev-ind  NOP)
              (inc-opt)
         )
        (if (eq? (car x) :BLOCK-IN)
              () ;;; No op
          (if (eq? (car x) :LOAD)
              (begin
               (set! prev x)
               (set! prev-ind i)
              )
               (set! prev #f)
          )
        )
         (set!  i(+ i 1))
     )
 )
)

(define (opt-load-set)
   (let ((v *comp-vector*)(n *comp-size*)(x 0) (prev #f))
     (do ((i 0))
         ((= n i) )
         (set! x (vector-ref v i))
         (when  (and prev  (set?  x)  (equal? (cdr prev)(cdr x)))
              (vector-set! v  i   NOP)
              (inc-opt)
         )
         (if (eq? (car x) :LOAD)
               (set! prev x)
               (set! prev #f)
         )
         (set!  i(+ i 1))
     )
 )
)

(define (opt-set-load)
   (let ((v *comp-vector*)(n *comp-size*)(x 0) (prev #f))
     (do ((i 0))
         ((= n i) )
         (set! x (vector-ref v i))
         (when  (and prev  (load?  x)  (equal? (cdr prev)(cdr x)))
              (vector-set! v  i   NOP)
              (inc-opt)
         )
         (if (eq? (car x) :SET)
               (set! prev x)
               (set! prev #f)
         )
         (set!  i(+ i 1))
     )
 )
)

(define (opt-jmp-label)
   (let ((v *comp-vector*)(n *comp-size*)(x 0) (prev #f)(lab 0))
     (do ((i 0))
         ((= n i) )
         (set! x (vector-ref v i))
         (when  (and prev  (label?  x)  (eq? lab (cadr x)))
              (vector-set! v  (- i 1)   NOP)
              (inc-opt)
         )
         (cond ((eq? (car x) :JMP)
                  (set! prev x) (set! lab (cadr x)))
                ((eq? (car x) :IF)
                  (set! prev x) (set! lab (caddr x)))
                (else
                   (set! prev #f))
         )
         (set!  i(+ i 1))
     )
 )
)

(define (opt-if-jmp)
   (let ((v *comp-vector*)(n *comp-size*)(x 0) (y 0)(prev #f)(lab 0))
     (do ((i 0))
         ((= n i) )
         (set! x (vector-ref v i))
         (when  (and prev   (eq? (car x) :JMP))
            (if (eq? lab (cadr x))  ;;; (:IF * lab)(:JMP lab)
               (begin
                 (vector-set! v  (- i 1)   NOP)
                (inc-opt)
               )
              (begin
                 (set! y (vector-ref v (+ i 1)))
                 (when (and (label? y) (eq? (cadr y) lab))
                    (vector-set! v   i    NOP)
                    (set! lab (cadr x))  ;;;:JMP lab
                    (set! y (if (eq? (cadr prev) :T) :F :T))
                    (vector-set! v  (- i 1)   (list :IF y lab))
                 )
              )
            )      
         )
         (if  (eq? (car x) :IF)
               (begin
                  (set! prev x) 
                  (set! lab (caddr x))
                )
               (set! prev #f)
         )
         (set!  i(+ i 1))
     )
 )
)


(define (label-clean)
    (let ((v *comp-vector*)(n *comp-size*)(x 0) (res ()))
     (do ((i 0))
         ((= n i) )
         (set! x (vector-ref v i))
         (if  (eq? (car x) :IF)
              (set! res (cons (caddr x) res))
         )
         (if  (eq? (car x) :JMP)
              (set! res (cons (cadr x) res))
         )
         (set!  i(+ i 1))
     )
    (label-erase res)
 )
)

(define (label-erase res)
  (let ((v *comp-vector*)(n *comp-size*)(x 0) )
     (do ((i 0))
         ((= n i) )
         (set! x (vector-ref v i))
         (when  (eq? (car x) :LABEL)
              (when (not (member (cadr x) res))
                (vector-set! v  i  NOP)
                (inc-opt)
              )
         )
       (set!  i(+ i 1))
     )
 )
  (make-label-link res)
)

(define (make-label-link res)
  (let ((ln ()) (x 0)(i 1))
   (set! res (sort res <))
   (while (pair? res)
     (set! x (car res))
     (set! res (cdr res)) 
     (while (and (pair? res) (eq? x (car res)))
        (set! res (cdr res)) 
        (set! i (+ i 1))
     )
    (set! ln (cons (cons x i) ln))
    (set! i 1)
  )
 (set! *label-link* ln)
))
        


(define (opt-load-jmp)
   (let ((v *comp-vector*)(n *comp-size*)(x 0) (prev #f))
     (do ((i 0))
         ((= n i) )
         (set! x (vector-ref v i))
         (if  (and prev (eq? (car x) :JMP))
              (load-jmp-sub v x i)
         )
         (if (eq? (car x) :LOAD)
               (set! prev x)
               (set! prev #f)
         )
         (set!  i(+ i 1))
     )
 )
)

(define (load-jmp-sub v x k)
  (let ((s #f) (lab (cadr x))(n *comp-size*))
    (do ((i (+ k 1)))
         ((or s  (= n i)) )
         (set! x (vector-ref v i))
         (when  (and (eq? (car x) :LABEL) (eq? (cadr x) lab) )
              (when (load? (vector-ref v (+ i 1))) 
                  (vector-set!  v (- k 1) NOP)
                  (inc-opt)
              )
           (set! s #t) ;;;owari
         )
       (set!  i(+ i 1))
   )
 )
)


(define (opt-label-label)
   (let ((v *comp-vector*)(n *comp-size*)(x 0) (prev #f)(lab 0))
     (do ((i 0))
         ((= n i) )
         (set! x (vector-ref v i))
         (when  (and prev  (label?  x) )
              (vector-set! v  (- i 1)   NOP)
              (label-change lab (cadr x))
              (inc-opt)
         )
         (if (label? x)
             (begin
                (set! prev x)
                (set! lab (cadr x))
             )
            (set! prev #f)
         )
         (set!  i(+ i 1))
     )
 )
)
;;;     (:JMP lab)-> (:JMP labnew)
(define (label-change lab labnew)
    (let ((v *comp-vector*)(n *comp-size*)(x 0) (res ()))
     (do ((i 0))
         ((= n i) )
         (set! x (vector-ref v i))
         (if  (eq? (car x) :IF)
             (if (eq? (caddr x) lab)
                (set-cdr! (cdr x) (cons labnew ()))
             )
         )
         (if  (eq? (car x) :JMP)
             (if (eq? (cadr x) lab)
                (set-cdr!  x (cons labnew ()))
             )
         )
         (set!  i(+ i 1))
     )
 )
)

(define (opt-jmp-nolabel)
   (let ((v *comp-vector*)(n *comp-size*)(x 0)(top 0)(tail #f) (prev #f))
     (do ((i 0))
         ((= n i) )
         (set! x (vector-ref v i))
         (set! top (car x))
         (when  (and prev top (not (label? x)) (not (lambda-begin? x)))
             (if  (and  tail (or (eq? top :BLOCK-OUT) (eq? top :LAMBDA-END)))
                 ()   ;;; No op
               (begin  
                  (vector-set! v   i   NOP)
                  (inc-opt)
                  (set! x prev)
               )
             )
         )
         (set! top (car x))
         (if  (eq? top :JMP) 
              (begin
                 (set! prev x)
                 (set! tail #f)
               )
               (set! prev #f)
         )
         (when  (eq? top :TAIL-JUMP)
                 (set! tail #t)
                 (set! prev x)
         )
         (set!  i(+ i 1))
     )
 )
)
;;; scm の値の追跡による、:IF, :JMPのlabelの最適化
;;;さらにloadの最適化もする。
;;; scmの値は、次のようにする。
;;;  <list of equivalent access>) 
;;;  =((:IMMIDIATE x) (:ENV x) (:TOP k)...)
;;;      x=#f ,#t(not #f), etc.
;;;   (:KNOWN #t) は:IFにより、not #fがわかっていることを示す。
;;; それ以外   不明である。
;;;  ()
(define (get-scm x scm i)   ;;; x operation
  (let ((top (car x)) (s 0))
    (cond ((eq? top :SET) 
              (cons (cdr x) scm)
                )   ;;;unchanged, added access
          ((eq? top :LOAD)
             (set! s (cadr x))
             ;;;  11.30  :UNDEF は最終段階
             ;;;(if (eq? s :UNDEF) 
             ;;;      (cons (list :IMMIDIATE s) ())
                   (cons (cdr x) ())
             ;;)
            )
          ((eq? top :BIND)
               (cons (list :ENV (cadr x)) scm))
          ((eq? top :STACK-NARG ) scm)
          ((eq? top :IF)
             (if (eq? (cadr x) :F) 
                     (cons (list :KNOWN #t) scm)
                     (cons (list :IMMIDIATE #f) scm)
              )
            )
          ((eq? top :LABEL )
            (set! s (vector-ref *comp-vector* (- i 1)))
            (if (and (eq? (car s) :JMP) (eq? (cdr (assq (cadr x) *label-link*)) 1))
                 scm
                 ()
            )
           )
          ((eq? top :BLOCK-IN)scm)
          ((eq? top :BLOCK-OUT)scm)
          ((eq? x NOP) scm)
          (else  () )   ;;;;   unknown
    )
))

(define (known-logic scm)
 (let ((x 0))
  (if (eq? scm ()) 
         #f   ;;; unknown
        (begin
           (set! x (assq :IMMIDIATE scm))
           (if x 
                (cons #t (cadr x))
              (begin
                 (set! x (assq :KNOWN scm))
                 (if x
                    (cons #t #t)
                    #f  ;;; unknown
                 )
              )
           )
        )
  )
))

(define (opt-scm-jmp)
   (let ((v *comp-vector*)(n *comp-size*)(x 0) (c 0) (logic #f)(ss 0)
            (scm '()) (scm-tmp 0))
     (label-clean)   ;;; for make label-link
     (do ((i 0))
         ((= n i) )
         (set! x (vector-ref v i))
         (set! logic (known-logic scm))
            (if (eq? (car x) :JMP)
               (scm-jmp-sub i x (cadr x) logic scm)
            )
            (when (eq? (car x) :IF)
             ;;; (format #t "opt-scm ~s~%" x)
              (if logic
                (begin
                  (set! c (cadr x))
                  (if (cdr logic) (set! ss :T)(set! ss :F))
                  (if (eq? c ss)
                      (begin   ;;;;  04.4.23 bug fix
                         (set! c (caddr x))   ;;;New
                         (set! x (list :JMP c)) ;;New
                         (vector-set! v i x) 
                         (scm-jmp-sub i x c logic scm);;;New
                      )
                      (begin
                       (vector-set! v i NOP)
                       (inc-opt)
                      )
                   )
                 )
                ;;;  non logic  不完全
                ;;;(when (pair? scm)
                (begin
                  (if (eq? (cadr x ) :T)
                     (begin
                       (set! logic (cons #t #t))
                       (set! scm-tmp (cons (list :KNOWN #t) scm))
                     )
                     (begin
                       (set! logic (cons #t #f))
                       (set! scm-tmp (cons (list :IMMIDIATE #f) scm))
                     )
                   )
                  (scm-jmp-sub i x (caddr x) logic scm-tmp)
                )
                ;;;)
             )
           )
           
         (when (and (pair? scm) (or (eq? (car x) :LOAD) (eq? (car x) :SET)))
               (set! ss (get-scm x () i) )
               (when (member (car ss) scm)
                    ;;(format #t "deleted opt-scm x ~s scm ~s i ~s~%" x scm i)
                     (vector-set! v i NOP)
                     (inc-opt)
               )
          )
         (set! scm (get-scm x scm i))
         (set!  i(+ i 1))
     )
 )
)

(define (opt-scm-jmp-value start scm logic)
   (let ((v *comp-vector*)(n *comp-size*)(x 0) (c 0) (ss 0))
     (do ((i start))
         ((<= n i) )
         (set! x (vector-ref v i))
        #|
         (when  logic
            (if (eq? (car x) :JMP)
               (scm-jmp-sub i x logic scm)
            )
            (when (eq? (car x) :IF)
               (set! c (cadr x))
               (if (cdr logic) (set! ss :T)(set! ss :F))
               (if (eq? c ss)
                      (begin
                         (set! x (list :JMP (caddr x)))
                         (vector-set! v i x)
                         (scm-jmp-sub i x logic scm)
                      )
                     (begin
                       (vector-set! v i NOP)
                       (inc-opt)
                     )
               )
             )
          )
         |#
         (when (and (pair? scm) (or (eq? (car x) :LOAD) (eq? (car x) :SET)))
            (set! ss (get-scm x () i))
              (when (member (car ss) scm)
                    ;;;(format #t "deleted jmp-value x ~s scm ~s i ~s~%" x scm i)
                     (vector-set! v i NOP)
                     (inc-opt)
               )
            
          )
         (set! scm (get-scm x scm i))
         (set! logic (known-logic scm))
         (if (pair? scm)
           (set!  i(+ i 1))
           (set! i n)
        )
     )
 )
)


(define (scm-jmp-sub start jmp lab logic scm)
   (let ((v *comp-vector*)(n *comp-size*)(x 0) (if-flag #f) (top 0)(c 0))
      (set! if-flag (eq? (car jmp) :IF))
     (do ((i (+ start 1)))
         ((<= n i) )
         (set! x (vector-ref v i))
         (set! top (car x))
         (when (and (eq? top :LABEL) (eq? (cadr x) lab))
            (set! scm (get-scm x scm i))
            (set! x (vector-ref v (+ i 1)))
            (set! top (car x))
            (cond  ((eq? top :JMP) ;;; no need logic
                      (if if-flag
                          (set-cdr!  (cdr jmp)  (cons (cadr x) ()))
                          (set-cdr!  jmp (cons (cadr x) ()))
                      )
                      (inc-opt)
                     )
                   ((and logic (eq? top :IF))
                      (set! c (if (cdr logic) :T :F))
                      (if (eq? c (cadr x))
                          (begin
                             (if if-flag
                                (set-cdr! (cdr  jmp) (cons (caddr x) ()))
                                (set-cdr!  jmp (cons (caddr x) ()))
                             )
                             (inc-opt)
                           )
                         ;;; jmp to next of if
                          (begin
                             (label++)
                             (if if-flag
                                (set-cdr!  (cdr jmp) (cons *label* ()))
                                (set-cdr!  jmp (cons *label* ()))
                             )
                             (insert-comp (+ i 2) (list :LABEL *label*))
                             (inc-opt)
                          )
                      )
                    )
                   (else  )
             )
            (set! logic (known-logic scm))
            (if (pair? scm) (opt-scm-jmp-value (+ i 1) scm logic)) 
            (set! i n) ;;;exit
         )
         (set!  i(+ i 1))
     )
 )
)
          
(define (insert-comp j obj)
   (let ((v *comp-vector*)(n *comp-size*)(x 0) )
     (do ()
         ((= n j) )
         (set! x (vector-ref v j))
         (vector-set! v j obj)
         (set! obj x)
         (set! j (+ j 1))
     )
 )
)
;;;  op jmp .... op lab

(define (opt-op-jmp)
   (let ((v *comp-vector*)(n *comp-size*)(x 0) )
     (do ((i 0))
         ((= n i) )
         (set! x (vector-ref v i))
         (when (eq? (car x) :JMP)
             (op-jmp-sub  i (cadr x) (vector-ref v (- i 1)))
         )
         (set!  i(+ i 1))
     )
))

(define (op-jmp-sub j lab prev)
   (let ((v *comp-vector*)(n *comp-size*)(x 0) (opt #f) )
     (do ((i (+ j 1)))
         ((<= n i) )
         (set! x (vector-ref v i))
         (when  (and  (label? x) (eq? lab (cadr x)))
            (when (equal? prev (vector-ref v (- i 1)))
              (vector-set! v  (- j 1)   NOP)
              (label++)
              (insert-comp (- i 1) (list :LABEL *label*))
              (vector-set! v  j   (list :JMP *label*))
              (inc-opt)
              (set! opt #t)
              (set! i n)
            )
         )
         (set!  i(+ i 1))
     )
   opt
 )
)
;;;;
;;;; change load :ENV ->load :IMMIDIATE if
;;;;    access= * 0
;;;;    value is :IMMIDIATE  :UNDEF () #t #f number
;;;;
(define (opt-load-imm)
   (let ((v *comp-vector*)(n *comp-size*)(x 0)(ac 0)(data 0)(var 0)(value 0) )
     (do ((i 0))
         ((= n i) )
         (set! x (vector-ref v i))
         (when (and (eq? (car x) :LOAD) (eq? (cadr x) :ENV))
             (set! var (caddr x))
             (set! data (assoc var *var-access*))
             (set! ac (cddr data))
             (when (eq?  (cadr ac) 0)
                (set! value (load-var-value () var))
                (when (and (pair? value)(eq? (car value) :IMMIDIATE) )
                   (set! ac (cadr value))
                   (when (or (symbol? ac)(keyword? ac)(number? ac)(char? ac))
                      (vector-set! v i (cons :LOAD value))
                      (inc-opt)
                   )
                )
              )
         ) 
        (set!  i(+ i 1))
     )     
))         


;;;;  delete BIND  access= 0 0 ,  0 *
(define (opt-nobind)
   (let ((v *comp-vector*)(n *comp-size*)(x 0)(ac 0)(data 0)(var 0) )
     (do ((i 0))
         ((= n i) )
         (set! x (vector-ref v i))
         (when (eq? (car x) :BIND)
             (set! var (cadr x))
             (set! data (assoc var *var-access*))
             (set! ac (cddr data))
             (when (eq?  (car ac) 0)
                (vector-set! v i NOP)
                (inc-opt)
                
                (if (> (cadr ac) 0)
                  (delete-set var)
                  (begin   ;;;check letrec
                    (if (member var *letrec-var*) 
                       (delete-set var)
                    )
                  )
                )
             )
         )
         (set!  i(+ i 1))
     )
))

(define (delete-set   var)
   (let ((v *comp-vector*)(n *comp-size*)(x 0)(ac 0)(data 0) )
     (do ((i 0))
         ((= n i) )
         (set! x (vector-ref v i))
         (when (and (eq? (car x) :SET) (eq? (cadr x) :ENV) (equal? var (caddr x)))
                (vector-set! v i NOP)
                (inc-opt)
         )
       (set!  i(+ i 1))
     )
))  

;;;; delete BLOCK with no bind
(define (opt-block)
   (let ((v *comp-vector*)(n *comp-size*)(x 0) )
     (do ((i 0))
         ((<= n i) )
         (set! x (vector-ref v i))
         (if (eq? (car x) :BLOCK-IN)
             (set! i (check-bind  i (cadr x)))
         )
         (set!  i(+ i 1))
     )
))

(define (check-bind start block)
   (let ((v *comp-vector*)(n *comp-size*)(x 0)(count 0)(top 0) (out 9999))
     (do ((i (+ start 1)))
         ((<= n i) )
         (set! x (vector-ref v i))
         (set! top (car x))
         (if (or (eq? top :BIND) (eq? top :LETBIND))
             (set! count (+ count 1))
         )
          (if (eq? top :BLOCK-IN)
             (set! i (check-bind  i (cadr x)))
         )
         (when (eq? top :BLOCK-OUT)
             (set! out i )
             (when (= count 0)
               (vector-set! v start NOP)
               (vector-set! v i  NOP)
               (inc-opt)
             )
            (set! i n)
         )
         (set!  i(+ i 1))
     ) 
   out
))

      
