;;;   ss web  browser
;;;     only Window managers  
;; 2004.12.1  separated from http.ss
;;;2005.1.5   ver1.3
(in-package "http")
(require "http-base")
(define *href-abs* ())
(define *href-relative* ())
(define *href-num* 0)
;;;
;;;(defstruct SWEB :www :header :html :url :status (:tablerow ()) (:tablecol ()) )

(define *web-scr*  ())
(define *active-web* 0)
;;;
(define *html-recv* ())
;;;(define *html-status* ())

(define (gen-web)
  (let*    (( www (gen-toplevel '.ssWEB))
            ( sta-lab  (tk-name www  '.stalab))
            ( status  (tk-name www  '.status))
            ( back  (tk-name www  '.back))
            ( save  (tk-name www  '.save))
           ;; ( web   (tk-name www  '.web))
            ( load  (tk-name www  '.load))
            ( href  (tk-name www  '.href))
           ;; ( key-lab  (tk-name www  '.keylab))
           ;;; ( keyword  (tk-name www  '.google))
            ( url-lab  (tk-name www  '.lab))
            ( url  (tk-name www  '.url))
            ( url-lab2  (tk-name www  '.lab2))
            ( url2  (tk-name www  '.url2))
            ( wexit  (tk-name www  '.wexit))
            ( header (tk-name www  '.header))
            ( hframe (tk-name www  '.hframe))
            ;;;( test  (tk-name www  '.hframe.test))
            ( html  (tk-name www  '.html))
            ( ysc  (tk-name www  '.ysc))
            ( hysc  (tk-name www  '.hysc))   
            ( hxsc  (tk-name www  '.hxsc))   
            ( popup  (tk-name www  '.popup))   
            (sweb (make-SWEB))
            (urlvar (tk-name www 'url))
            (first (null? *web-scr*))
            (file-dld 0)
           )
   (label sta-lab :text "Status" :width 8)
   (label status :text "OK           " :width 75)
   (if first
       (button wexit :text "EXIT" :activebackground 'red 
                  :command '(bye))     ;;; to be modify
       (button wexit :text "CLOSE" :activebackground 'red
                  :command (lambda () (close-ssweb sweb)))
   )
   (button back :text "Back" :command (lambda() (url-back sweb)))
   (button save :text "Save" :command (lambda()(save-html sweb)))  ;;; html 
   (button load :text "Load" :command (lambda()(load-html sweb file-dld)))
  (label  href :text "Href in html" )
  ;; (button web  :text "XWEB" :command (lambda()(tag-html (get-html-recv sweb) )))
  ;;; (label key-lab :text "Google")
  ;;; (entry keyword :width 20)
   (label url-lab :text "URL")
   (entry url )
   (label url-lab2 :text "href-URL")
   (entry url2 :textvariable urlvar )
   (grid url-lab :row 0 :column 0 )
   (grid  url :columnspan 4  :row 0 :column 1 :sticky 'news)
   ;;(grid  wexit    :row 0 :column 6 :sticky 'nes)
   (grid  wexit    :row 0 :column 8 :sticky 'nes)
 ;;  (grid key-lab :row 0 :column 3 )
 ;;;  (grid  keyword :columnspan 2 :row 0 :column 4)
   (grid sta-lab :row 1 :column 0 )
   (grid  status :columnspan 5 :row 1 :column 1 :sticky 'nws)
  ;; (grid  web :row 1 :column 3)
   (grid  back :row 0 :column 5)
  ;; (grid  load :row 1 :column 4)
   (grid  load :row 0 :column 6)
   ;;(grid  save :row 1 :column 5)
   (grid  save :row 0 :column 7)
   (grid  href :row 1 :column 5)
   (text header  :height 12 :exportselection #t :yscrollcommand
       (lambda l (apply (function ysc)  'set l)))
   (scrollbar ysc :orient 'vertical 
            :command (lambda l (apply (function header) 'yview l)))
   (grid  header  :sticky 'news :columnspan 2 :row 2)
   (grid   ysc :sticky 'nws :row 2 :column 2)
;;;
   (frame hframe)
   (grid  hframe  :sticky 'news :columnspan 6 :row 2 :column 3)
   (href-win hframe)
   ;;;(format #t "hframe ~s~%" hframe)

  ;;;; 04.5.6   text enable expand
     (grid 'rowconfigure www 4  :weight 1)
      (grid 'columnconfigure www 1 :weight 1)
;;;
   (text html  :exportselection #t :yscrollcommand
     (lambda l (apply (function hysc) 'set l))
     :xscrollcommand   (lambda l (apply (function hxsc) 'set l))
    )
   (scrollbar hysc :orient 'vertical
            :command (lambda l (apply (function html) 'yview l)))
   (scrollbar hxsc :orient 'horizontal
            :command (lambda l (apply (function html) 'xview l)))
   (grid url-lab2 url2 :row 3)
   (grid  url2  :columnspan 4 :row 3 :column 1 :sticky 'news)
   (grid  html  :sticky 'news :columnspan 8 :row 4)
   (grid   hysc :sticky 'nws :row 4 :column 8)
   (grid   hxsc :sticky 'news :row 5 :columnspan 8 )

   (set-SWEB sweb :www  www :header header :html html :url url :status status 
           :popup popup :urlvar urlvar)

  (bind url "<Return>"
           (lambda ()(set! *active-web* sweb) (ss-browse (funcall url 'get))))

  (bind url2 "<Return>"
           (lambda ()(set! *active-web* sweb) (ss-browse (funcall url2 'get))))
#|
  (bind url2 "<Return>"
           (lambda ()(set! *active-web* sweb) (http-get *URL*)))
|#
 ;;;  (bind keyword "<Return>"
 ;;;          (lambda ()(set! *active-web* sweb) (google (funcall keyword 'get))))

     (funcall html  'tag 'bind  'popup  "<Button-3>" 
              (lambda(X Y) (popup-configure popup)(tk_popup popup X Y)))  
  
   (push sweb  *web-scr*)
   (set! *active-web* sweb)
   (set! file-dld (make-DLD))
   (init-tag-def html)  ;;; in html-font.ss
   (make-popup-menu sweb)
   (init-font-def html)
 www
))

(define (close-ssweb sweb)
  (let* ((www (SWEB-www sweb)))
      (set! *web-scr* (remove sweb *web-scr*))
      (destroy www)
))
     
(define (save-html www)   ;;; txt-win 
   (let* ((out 0)(text 0)(file (save-file-name ".html"  "save html")) (res ()))
     (when file
       (set! out (open-output-file file)) 
        ;;;(set! text (funcall txt-win  'get "1.0" 'end))
        ;;;(display text out)
        (set! res (assq www *html-recv*))
        (when res
           (set! res (cdr res))
           (while (pair? res)
              (display (pop res) out)
              (newline out)
           )
        ) 
        (close-port out)
        (format #t "~s saved~%" file)
     )
))
;;;  web entry
(define (ss-browse url)
    (set! url (regexp url #"[^\s\n]++"))
    (if (string-index "http://" url)
           (http-get  url)
           (file-browse url)
    )
)

(define (url-back sweb)
  (let* ((his (SWEB-url-his sweb)) (url 0))
   (when (pair? (cdr his))
      (pop his)
      (set! url (pop his))
      (set-SWEB sweb :url-his his)
     (ss-browse url)
   )
))
;;;;   display functions
(define (get-screen dld)
     (cond ((eq?  dld #t) *active-web*)
           ( dld 
              (if (DLD-ishtml dld) (DLD-screen dld)  #f)
           )
           (else #f)
     )
)
             
(define (clear-header  dld)
  (let* ((w #f ))
    (set! w (get-screen dld))
    (if w
          (begin
            (set! w (SWEB-header w))
          )
       (set! w *dl-header*)
    )
   (funcall  w 'delete "1.0" 'end)
))


(define (clear-html dld)
  (let* ((w 0)(url #f) (ent 0)(his 0))
     (set! w (get-screen dld))
     (if (structure? dld) (set! url (DLD-url dld)))
     (set! *href-abs* ())
     (set! *href-relative* ())
     (when w
        (set-SWEB w :popupfunc ()    ;;;;  to be delete if we solve a bug
                           )
        (funcall (SWEB-html w) 'delete "1.0" 'end)
        (when url
          (set! ent (SWEB-url  w))
          (funcall ent 'delete 0 'end)
          (funcall ent 'insert  0 url)
          (funcall (SWEB-html w) 'delete "1.0" 'end)
          (set! his (SWEB-url-his w))
          (set-SWEB  w :url-his (cons url his))
        )
     )
))


(define (insert-header str dld)
  (let* ((w #f ))
     ;;;(format #t "isert-header: ~s~%" str)
     (set! w (get-screen dld))
    (if w
       (set! w (SWEB-header w))
       (set! w *dl-header*)
    )
   (when w
      (funcall  w 'insert 'insert (tk-string str #\newline))
  )
))

(define (make-open-url x)
  (let* ((web *active-web*) )
  ;;;(lambda() (format #t "~s~%" url))
 #|  very heavy  gen-web
  (if (cdr x)
     (lambda() (gen-web)(http-get (car x)))
     (lambda() (set! *active-web* web)(http-get (car x)))
  )
  (if (url-html? (car x))
      (lambda() (set! *active-web* web)(http-get-force (car x)))
      (lambda() (set! *active-web* web)(http-get (car x)))
  )
|#
   (lambda() (set! *active-web* web)(http-get  (car x)))
))

;;;(flush)  ;;; Why???
;;;(format #t "foo 1~%")

(define (insert-html str)
  (let* ((x 0)(abs 0)(tag 0)(w  *active-web*  )(memo str)(new ""))
   (when w
      (set! w  (SWEB-html w))
      (set! str (adr-tfr str))
      (while (pair? str)
           (set! x (pop str))
           (if (pair? x)
                (begin
                 ;;; (format #t "insert-html x ~s~%" x)
                  (set! abs (if (cdr x) 'href_abs 'href_relative))
                  (set! tag (tk-string abs *href-num*))
                  (inc *href-num*)
                  ;;(funcall w 'tag 'configure  tag )
                  (funcall w 'tag 'bind  tag "<Button-1>" (make-open-url  x))
                  (funcall w 'insert 'insert (car x) (list abs tag 'popup))
                  (set! new (string-append new (car x)))
                )
                (begin
                    (funcall w 'insert 'insert x)
                     (if (string? x) (set! new (string-append new  x)))
                )
           )
      )
  )
  (if (equal? new "") memo new)
))

;;;  if force status is displayed in main web-window else in dl-win
;;;
(define (write-status str dld)
  (let* ((w #f))
    ;;;(set! *html-status* str)
    (set! w (get-screen dld))
    (if w
          (set! w (SWEB-status w))
          (set! w  *dl-status*)
    )
    (if w
       (funcall w 'configure :text str)
       (format #t "status:~a~%" str)
    )
   (update)
))

;;;(gen-web)


;;;;  *****************************************************************
;;;;
(define (adr-tfr str)
  (let* ((x 0)(res '(#\newline)))
    (while str
       (set! x (adr-tfr-aux str))
       (if x
          (begin
             (push (car x) res)
             (push (cadr x)  res)    ;;; href url
             (set! str (caddr x))
          )
         (begin
           (push str res)
           (set! str #f)
         )
       )
    )
  (reverse res)
))

(define (adr-tfr-aux  str)
  (let* ((x 0)(s 0)(top 0)(rest 0)(url 0) (abs #t))
    (set! x (string-index "href=" str :nocase))
            ;;; (if x  (format #t "~%adr-tfr :~s ~%~s~%" str x))
    (if x
      (begin
         (set! top (substring str 0 (+ x 5)))
         (set! rest (substring str  (+ x 5) :end))
               ;;;  (format #t "adr-tfr rest:~s~%" rest)
         (set! x (regexp rest  #"^(\"?([\w.?%&=+*@:/~-]+)\"?)(\s|>)" :nocase ))
               ;;;;   must include url-encode char's
         (if x
            (begin 
              (set! x (match-string  2))
              (set! s (match-string 1))
                ;;; (format #t "adr-tfr found:~s~%" x)
              (if x 
                  (begin
                      (set! url (get-abs-url  x))
                      (set! abs (eq? url  x))
                      (if abs
                             (push url *href-abs*)
                             (push url *href-relative*)
                      )
                      (set! rest (substring rest (string-length  s) :end))
                      (if (equal? rest "") (set! rest #f))
                      (list  top (cons url abs)  rest)
                  )
                 #f
              )
            )
           #f
         )
       )
      #f
    )
))

;;;
(define (file-browse file dld)
   (if (file-exists? file)
      (let* ((temp (make-temp-file)) )
         ;;;(write-status " HTML FILE" #t)
         (clear-header #t)
         (insert-header file #t)
         (copy-file file temp)
         (trans-msg-file  temp dld)
      )
    (write-status "file not exists" #t)
  )
)

(define (load-html sweb dld)
 (let* ((file #f))
  (set! *active-web* sweb)
  (set! file  (get-file-name "*.htm" "*.html"))
  (if file (file-browse file dld))
))        
;;;
(define (html-recv res dld)
   (let* ((scr #f) (x 0))
       (if dld (set! scr (DLD-screen dld))) 
      (if (not scr) (set! scr *active-web*))
      (set! x (assq scr *html-recv*))
     (if x 
         (set-cdr! x res)
         (push (cons scr res) *html-recv*)
     )
;;; (format #t "html-recv ~s~%" dld)
   ;;;(write-status (tk-string *html-status* "  complete") dld)
  (if (structure? dld)
      (write-status (tk-string "HTTP/1.0 " (DLD-status  dld) "  complete") dld)
      (write-status (tk-string "file load "  "  complete") #t)
 )
))

(define (get-html-recv sweb)
  (let* ((x (assq sweb *html-recv*)))
     (set!  *active-web* sweb)
     (if x (cdr x) ())
))



