;;;  
;;;    cp recursive
;;;  2019.9.4  recursive
;;;  ss -p /Volumes/SP/AIFF /Volumes/Hommie -f sscp_rec.ss
;;;  defined  /opt/local/bin/sscp
;;;  sscp  /Volumes/SP/AIFF /Volumes/Hommie
;;;  copy AIFF to Hommie/
;;;    2 or more
;;;  sscp  /Volumes/SP/AIFF/B* /Volumes/Hommie/AIFF




(define (com-dir-rec f destdir)
  (let* ((clis 0)(dir 0)(c 0)(g 0)(new 0)(newdir 0)(x 0))
     (chdir f)
     (format #t "~%directory  ~a~%" f)
    ;;; (system (tk-string "open " f))
    ;;(system (tk-string "find . -name '*3*.c'"))
    (set! clis (glob-file "*"))  ;;; Note glob takes all
    (set! dir (glob-dir ))
    (set! newdir  (tk-string  destdir "/" f ))
    (when (and (or (pair? clis)(pair? dir))(not (file-exists? newdir)))
       (format #t "create: mkdir  ~a~%" newdir)
       (mkdir  newdir)
    )
     (while (pair? dir)
      (set! g (pop dir))
      (com-dir-rec g  newdir)
      (chdir "../")
     )
   (if (pair? clis)
     (begin
       (while (pair? clis)
         (set! c (pop clis))
         (set! x (tk-string  newdir "/"  c))
         (when (cp-need  c x)
           (format #t "cp-file: ~a~%" x)
           ;;;(copy-file c x)
           (run-process "cp" "-p" c x :wait)
         )
       )
     #t   ;;; done!
   )
    #f
  )
))

(define (cp-need c x)
  (let* ((stat 0)(cstat 0))
   (if (file-exists? x)
      (begin
        (set! cstat (cdr (file-stat c)))  ;; size time date
        (set! stat (cdr (file-stat x)))  ;; size time date
        (if (<= (cadr cstat) (cadr stat)) ;;  already new one
            #f
            #t
        )
      )
     #t
   )
))
      
;;;
(define (help)
   (format #t "use: sscp dir1 ...  Dest-Dir  ~%")
   (format #t "for make   Dest-Dir/dir1 ... ~%")
;;;  sscp  /Volumes/SP/AIFF /Volumes/Hommie
   (bye)
)

(if (<= (length *argv*) 1) (help))
(define Drive-list 
   (let* ((res ()) (d 0)) 
      (while (pair? (cdr *argv*))
          (push (pop *argv*)  res)
      )
      (reverse res)
    )
)
(define Newdir (car *argv*))
(if (not (equal? (string-index "/" Newdir)  0))
      (set! Newdir (tk-string (pwd) "/" Newdir))
 )
(format #t "Newdir  ---> ~a~%" Newdir)
(if (not (file-exists? Newdir))
   (mkdir Newdir)
)

(while (pair? Drive-list)
 (let*  ((Drive (pop Drive-list)))
;;;(define artist (pop *argv*))
;;;(define Newdir (tk-string (pwd) "/Newdir3"))
(let* ((end (string-rindex "/" Drive))(artist 0)(done 0)(drive 0))

   (when (equal? end (- (string-length Drive) 1))
      (set! Drive (substring Drive 0 :end -1))
      (set! end (string-rindex "/" Drive))
   )
  (if (not (file-is-directory? Drive))
      (bye)
  )
   (if end
        (begin
            (set! artist  (substring Drive  (+ end 1) :end))
            (set! drive (substring Drive 0 end))
            
            (chdir drive)
            (com-dir-rec artist Newdir)
            (chdir "../")
           ;;; (if done (bye) )  ;;; done!
          )
         ;else
          (begin
            (com-dir-rec Drive Newdir)
            (chdir "../")
          )
       )
)
))

(bye)

